/* Simple test prog to see if we can mmap video memory.
 * Will mmap, and then attempt to black out the top part of the screen.
 * So make sure you have a "refresh" button on your window manager!
 * Also, make sure your system has chowned /dev/fb/whatever
 * so that it is writaable by you first.
 */

#include <stdio.h>
#include <unistd.h>

#include <string.h> /* for memset */
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <errno.h>

#include <sys/sysi86.h>
#include <sys/psw.h>

int main(int argc, char *argv[]){
	char *devpath;
	char *mapaddr;
	int fd;

	if(argc<2){
		puts("Need a fb devpath");
		exit(1);
	}
	devpath=argv[1];
	printf("opening %s\n",devpath);
	fd=open(devpath, O_RDWR);
	if(fd<0){
		perror("could not open file");
		exit(1);
	}

#ifdef notnow
	if(sysi86(SI86V86, V86SC_IOPL, PS_IOPL) < 0){
		perror("call to sysi86 failed");
		exit(1);
	} else {
		puts("Did sysi86 call successfully");
	}
#endif
/*#define HARDCODE 0xd6000000*/

#define HARDCODE 0x10000


	mapaddr=mmap((caddr_t)0, 16384, (PROT_READ|PROT_WRITE),
	             MAP_SHARED, fd, HARDCODE);
	if(mapaddr == MAP_FAILED){
		perror("could not mmap video memory");
		exit(1);
	}
	printf("mmap returned %p\n",mapaddr);

	puts("Successfully did map. Now going to zero out stuff");
	sleep(5);
	
	memset(mapaddr, 0, 16384);

	puts("Done. Now you clean it up!");

	close(fd);

	exit(0);
}
